<template>
    <div
        ref="element"
        class="w-5/6 md:w-full flex rounded-lg shadow hover:shadow-lg hover:bg-gray-100 cursor-pointer px-4 py-6 mb-4"
    >
        <div class="w-2/6 md:w-1/3 flex justify-center">
            <div class="w-9/12 md:w-6/12">
                <img class="w-full" :src="item.url" :alt="item.name" />
            </div>
        </div>
        <div class="w-2/6 w-1/3">
            <h2 class="text-lg md:text-xl">{{ item.name }}</h2>
            <h1 class="text-2xl md:text-3xl font-semibold">{{ getWeight() }}</h1>
        </div>
        <div class="w-3/6 md:w-1/3 flex flex-col justify-center">
            <div class="w-full hidden md:flex items-center shadow-md p-3">
                <div class="w-1/5 flex items-center justify-center">
                    <span
                        ref="subtract1"
                        @click="subtract"
                        class="w-8 h-8 flex justify-center items-center rounded-full shadow"
                    >
                        <font-awesome-icon size="lg" icon="minus" />
                    </span>
                </div>
                <div class="w-3/5 flex items-center justify-center">
                    <span
                        class="text-base md:text-3xl font-bold"
                    >{{ tweenedNumberofItems.value | toInteger }}</span>
                </div>
                <div class="w-1/5 flex items-center justify-center">
                    <span
                        ref="add1"
                        @click="add"
                        class="w-8 h-8 flex justify-center items-center rounded-full shadow"
                    >
                        <font-awesome-icon size="lg" icon="plus" />
                    </span>
                </div>
            </div>
            <div class="w-full flex md:hidden flex-wrap items-center shadow-md p-1">
                <div class="w-full flex items-center justify-center">
                    <span class="text-2xl font-bold">{{ tweenedNumberofItems.value | toInteger }}</span>
                </div>
                <div class="w-1/2 flex items-center justify-center">
                    <span
                        ref="subtract2"
                        @click="subtract"
                        class="w-8 h-8 flex justify-center items-center rounded-full shadow"
                    >
                        <font-awesome-icon size="lg" icon="minus" />
                    </span>
                </div>
                <div class="w-1/2 flex items-center justify-center">
                    <span
                        ref="add2"
                        @click="add"
                        class="w-8 h-8 flex justify-center items-center rounded-full shadow"
                    >
                        <font-awesome-icon size="lg" icon="plus" />
                    </span>
                </div>
            </div>
            <div class="flex w-full justify-center mt-6">
                <span class="text-lg font-semibold mr-4">Weight</span>
                <span
                    class="text-lg font-bold"
                >{{ tweenedNumberofItems.value * getWeight() | toInteger }}</span>
            </div>
        </div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { State } from 'vuex-class'
import { Watch, Prop } from 'vue-property-decorator'
import { ICategoriesState, IItem } from '../categories/store/types'
import anime from 'animejs'
import TWEEN from '@tweenjs/tween.js'

interface items {
    value: number
}

@Component({
    filters: {
        toInteger(val: number) {
            return Math.floor(val)
        },
    },
})
export default class App extends Vue {
    @Prop() readonly item: IItem
    @Prop() readonly category: string
    @Prop() readonly index: number
    @Prop({ default: 10 }) readonly steps: number
    @Prop({ default: null }) existingNumber: number | null
    @Prop({ default: 70 }) existingTotalCapacity: number
    @Prop({ default: 0 }) existingTotalWeight: number

    @State('Categories') Categories_State: ICategoriesState

    $refs: {
        [key: string]: HTMLElement
    }

    created() {
        if (this.existingNumber !== 0 && this.existingNumber !== null) {
            this.numberofItems.value = this.existingNumber
        }
    }

    mounted() {
        if (!this.validateAdd() && this.existingNumber !== null) {
            const el = this.$refs.element
            this.beforeEnterDanger(el)
        }
    }

    // Data
    numberofItems: items = { value: 0 }
    tweenedNumberofItems: items = { value: 0 }

    // Computed
    get isSelected(): boolean {
        return this.numberofItems.value > 0
    }

    get weight(): number {
        return this.numberofItems.value * this.getWeight()
    }

    get selection() {
        return {
            name: this.item.name,
            number: this.numberofItems.value,
            unitWeight: this.getWeight(),
            weight: this.weight,
        }
    }

    // Watchers
    @Watch('isSelected')
    watchIsSelected(val: boolean) {
        if (val === true) {
            const el = this.$refs.element
            this.beforeEnterSelection(el)
        } else {
            const el = this.$refs.element
            this.beforeLeaveSelection(el)
        }
    }

    @Watch('numberofItems', { deep: true })
    watchNumberofItems(val: number, oldVal: number) {
        if (oldVal !== undefined) {
            const animate = () => {
                if (TWEEN.update()) {
                    requestAnimationFrame(animate)
                }
            }

            new TWEEN.Tween(this.tweenedNumberofItems)
                .to(this.numberofItems, 400)
                .start()

            animate()
        }
    }

    // Methods
    getWeight(): number {
        const index = (this.Categories_State.categories[
            this.category
        ] as IItem[]).findIndex(item => item.name === this.item.name)
        return (this.Categories_State.categories[this.category] as IItem[])[
            index
        ].weight
    }

    validateAdd(): boolean {
        if (
            this.existingTotalWeight + this.steps * this.getWeight() >
            this.existingTotalCapacity
        ) {
            return false
        }
        return true
    }

    validateSubtract(): boolean {
        if (this.existingTotalWeight - this.steps < 0) {
            return false
        }
        return true
    }

    add() {
        if (!this.validateAdd()) {
            const el = this.$refs.element
            this.beforeEnterDanger(el)
            return
        }
        this.numberofItems.value += this.steps
        const els = []
        els.push(this.$refs.add1)
        els.push(this.$refs.add1)
        els.forEach(el => {
            this.beforeEnterOperation(el)
        })
        this.$emit('output', {
            [this.category]: this.selection,
        })
    }

    subtract() {
        if (!this.validateSubtract()) {
            return
        }
        if (!this.validateAdd()) {
            const el = this.$refs.element
            this.beforeLeaveDanger(el)
        }
        this.numberofItems.value -= this.steps
        const els = []
        els.push(this.$refs.subtract1)
        els.push(this.$refs.subtract2)
        els.forEach(el => {
            this.beforeEnterOperation(el)
        })
        this.$emit('output', {
            [this.category]: this.selection,
        })
    }

    // Animation
    // 1(a). on Selection
    beforeEnterSelection(el: HTMLElement) {
        el.style.backgroundColor = '#FFFFFF'
        this.enterSelection(el)
    }
    enterSelection(el: HTMLElement) {
        anime({
            targets: el,
            backgroundColor: '#FFFAF0',
        })
    }
    // 1(b). on Deselection
    beforeLeaveSelection(el: HTMLElement) {
        el.style.backgroundColor = '#FFFAF0'
        this.leaveSelection(el)
    }
    leaveSelection(el: HTMLElement) {
        anime({
            targets: el,
            backgroundColor: '#FFFFFF',
        })
    }
    // 1(c). on Danger
    beforeEnterDanger(el: HTMLElement) {
        el.style.backgroundColor = '#FFFAF0'
        this.enterDanger(el)
    }
    enterDanger(el: HTMLElement) {
        anime({
            targets: el,
            backgroundColor: '#F56565',
        })
    }
    // 1(d). on safe
    beforeLeaveDanger(el: HTMLElement) {
        el.style.backgroundColor = '#F56565'
        this.leaveDanger(el)
    }
    leaveDanger(el: HTMLElement) {
        anime({
            targets: el,
            backgroundColor: '#FFFAF0',
        })
    }
    // 2. on Add and Subtract
    beforeEnterOperation(el: HTMLElement) {
        el.style.transform = 'scale(0.5)'
        this.enterOperation(el)
    }
    enterOperation(el: HTMLElement) {
        anime({
            targets: el,
            scale: 1,
        })
    }
}
</script>